
#include "stdio.h"
#include "stdlib.h"

#define pix1 "r3"
#define pix2 "r12"
#define scr "r2" 

/*
horizontal flip 4 pixels

and r1,r0,#0xFF00
mov r1,r1,lsl#8
and r2,r0,#0xFF0000
orr r1,r1,r2,lsr#8
orr r1,r1,r0,lsl#24	;@ 0x44000000
orr r1,r1,r0,lsr#24	;@ 0x44000011

  */
int calcOffset(int curroffset,int currbit, int bitmask)
{
	switch(currbit&7)
	{
	case 0:
		if(bitmask&(1<<1)) return(1-curroffset);
	//no break - just fall through
	case 1:
		if(bitmask&(1<<2)) return(2-curroffset);
	case 2:
		if(bitmask&(1<<3)) return(3-curroffset);
	case 3:
		if(bitmask&(1<<4)) return(4-curroffset);
	case 4:
		if(bitmask&(1<<5)) return(5-curroffset);
	case 5:
		if(bitmask&(1<<6)) return(6-curroffset);
	case 6:
		if(bitmask&(1<<7)) return(7-curroffset);
	case 7:
		return(320-curroffset);
	}
	return(320-curroffset);
}
	
int generate_code8(char *filename)
{
	int shift=0;
	int i=0;
	FILE *f;

	f=fopen(filename,"w+t");
	
	fprintf(f,"    ;@ asmDrawTile8(uint32 cache,uint32 solidbuf,uint32 OffsetGP32,uint32 Flip);:\n");
	fprintf(f,"    \n");
	fprintf(f,"    drawtile_align0_pointer: .word drawtile_align0\n");
	fprintf(f,"    \n");
	fprintf(f,"    .global asmDrawTile8\n");
	fprintf(f,"asmDrawTile8:\n");
	fprintf(f,"    stmfd sp!,{r4,r5,lr}\n");
	// choose render
	fprintf(f,"    ands r5,r2,#3\n");
	//fprintf(f,"    ldmnefd sp!,{r4,r5,lr}\n");
	fprintf(f,"    ldr r4,[pc,r5,lsl#2]\n");
	fprintf(f,"    b 1f\n");
	fprintf(f,"    .word drawtile_align0\n");
	fprintf(f,"    .word drawtile_alignX\n");
	fprintf(f,"    .word drawtile_alignX\n");
	fprintf(f,"    .word drawtile_alignX\n");
	fprintf(f,"1:\n");
	//Calc lines to render
	fprintf(f,"    add r5,r0,#8\n");
	fprintf(f,"    and r3,r1,#7\n");
	fprintf(f,"    add r0,r0,r3\n");
	fprintf(f,"    add r5,r5,r3,lsl#3\n");
	fprintf(f,"    \n");
	fprintf(f,"    mov r1,r1,lsr#16\n");
	fprintf(f,"    ldrb r3,[r0],#1\n");
	fprintf(f,"    ldr pc,[r4,r3,lsl#2]\n");
	// 0 byte aligned
	fprintf(f,"drawtile_align0:\n");
	for(i=0;i<0x100;i+=4)
	{
		fprintf(f,"    .word drawtile_align0_%x, drawtile_align0_%x, drawtile_align0_%x, drawtile_align0_%x\n",i,i+1,i+2,i+3);
	}
	// any alignment - compatible but slow
	fprintf(f,"drawtile_alignX:\n");
	for(i=0;i<0x100;i+=4)
	{
		fprintf(f,"    .word drawtile_alignX_%x, drawtile_alignX_%x, drawtile_alignX_%x, drawtile_alignX_%x\n",i,i+1,i+2,i+3);
	}
	/*fprintf(f,"drawtile_align1:\n");
	for(i=0;i<0x100;i+=4)
	{
		fprintf(f,"    .word drawtile_align1_%x, drawtile_align1_%x, drawtile_align1_%x, drawtile_align1_%x\n",i,i+1,i+2,i+3);
	}
	fprintf(f,"drawtile_align2:\n");
	for(i=0;i<0x100;i+=4)
	{
		fprintf(f,"    .word drawtile_align2_%x, drawtile_align2_%x, drawtile_align2_%x, drawtile_align2_%x\n",i,i+1,i+2,i+3);
	}
	fprintf(f,"drawtile_align3:\n");
	for(i=0;i<0x100;i+=4)
	{
		fprintf(f,"    .word drawtile_align3_%x, drawtile_align3_%x, drawtile_align3_%x, drawtile_align3_%x\n",i,i+1,i+2,i+3);
	}*/

	// Any alignment - byte access compatibilty mode
	for(i=0;i<0x100;i++)
	{
		fprintf(f,"drawtile_alignX_%x:\n",i);
		
		if ((i&0xF)&&(i&0xF0))
		{
			fprintf(f,"    ldmia r5!,{r3,r12}\n");
		}
		else if ((i&0x3)&&(i&0xC))
		{
			fprintf(f,"    ldr r3,[r5],#8\n");
		}
		else if (i&0x3)
		{
			fprintf(f,"    ldrh r3,[r5],#8\n");
		}
		else if (i&0xC)
		{
			fprintf(f,"    add r5,r5,#2\n");
			fprintf(f,"    ldrh r3,[r5],#6\n");
		}
		else if ((i&0x30)&&(i&0xC0))
		{
			fprintf(f,"    add r5,r5,#4\n");
			fprintf(f,"    ldr r12,[r5],#4\n");
		}
		else if (i&0x30)
		{
			fprintf(f,"    add r5,r5,#4\n");
			fprintf(f,"    ldrh r3,[r5],#4\n");
		}
		else if (i&0xC0)
		{
			fprintf(f,"    add r5,r5,#6\n");
			fprintf(f,"    ldrh r3,[r5],#2\n");
		}

		switch(i&0xF)
		{
		case 0:
			fprintf(f,"    add %s,%s,#%d\n",scr,scr,calcOffset(0,0,i));
			break;
		case 1:
			fprintf(f,"    strb %s,[%s],#%d\n",pix1,scr,calcOffset(0,0,i));
			break;
		case 2:
			fprintf(f,"    add %s,%s,#1\n",scr,scr);
			fprintf(f,"    mov %s,%s,lsr#8\n",pix1,pix1);
			fprintf(f,"    strb %s,[%s],#%d\n",pix1,scr,calcOffset(1,1,i));
			break;
		case 3:
			fprintf(f,"    strb %s,[%s],#1\n",pix1,scr);
			fprintf(f,"    mov %s,%s,lsr#8\n",pix1,pix1);
			fprintf(f,"    strb %s,[%s],#%d\n",pix1,scr,calcOffset(1,1,i));
			break;
		case 4:
			fprintf(f,"    add %s,%s,#2\n",scr,scr);
			fprintf(f,"    mov %s,%s,lsr#16\n",pix1,pix1);
			fprintf(f,"    strb %s,[%s],#%d\n",pix1,scr,calcOffset(2,2,i));
			break;
		case 5:
			fprintf(f,"    strb %s,[%s],#2\n",pix1,scr);
			fprintf(f,"    mov %s,%s,lsr#16\n",pix1,pix1);
			fprintf(f,"    strb %s,[%s],#%d\n",pix1,scr,calcOffset(2,2,i));
			break;
		case 6:
			fprintf(f,"    add %s,%s,#1\n",scr,scr);
			fprintf(f,"    mov %s,%s,lsr#8\n",pix1,pix1);
			fprintf(f,"    strb %s,[%s],#1\n",pix1,scr);
			fprintf(f,"    mov %s,%s,lsr#8\n",pix1,pix1);
			fprintf(f,"    strb %s,[%s],#%d\n",pix1,scr,calcOffset(2,2,i));
			break;
		case 7:
			fprintf(f,"    strb %s,[%s],#1\n",pix1,scr);
			fprintf(f,"    mov %s,%s,lsr#8\n",pix1,pix1);
			fprintf(f,"    strb %s,[%s],#1\n",pix1,scr);
			fprintf(f,"    mov %s,%s,lsr#16\n",pix1,pix1);
			fprintf(f,"    strb %s,[%s],#%d\n",pix1,scr,calcOffset(2,2,i));
			break;
		case 8:
			fprintf(f,"    add %s,%s,#3\n",scr,scr);
			fprintf(f,"    mov %s,%s,lsr#24\n",pix1,pix1);
			fprintf(f,"    strb %s,[%s],#%d\n",pix1,scr,calcOffset(3,3,i));
			break;
		case 9:
			fprintf(f,"    strb %s,[%s],#3\n",pix1,scr);
			fprintf(f,"    mov %s,%s,lsr#24\n",pix1,pix1);
			fprintf(f,"    strb %s,[%s],#%d\n",pix1,scr,calcOffset(3,3,i));
			break;
		case 0xA:
			fprintf(f,"    add %s,%s,#1\n",scr,scr);
			fprintf(f,"    mov %s,%s,lsr#8\n",pix1,pix1);
			fprintf(f,"    strb %s,[%s],#2\n",pix1,scr);
			fprintf(f,"    mov %s,%s,lsr#16\n",pix1,pix1);
			fprintf(f,"    strb %s,[%s],#%d\n",pix1,scr,calcOffset(3,3,i));
			break;
		case 0xB:
			fprintf(f,"    strb %s,[%s],#1\n",pix1,scr);
			fprintf(f,"    mov %s,%s,lsr#8\n",pix1,pix1);
			fprintf(f,"    strb %s,[%s],#2\n",pix1,scr);
			fprintf(f,"    mov %s,%s,lsr#16\n",pix1,pix1);
			fprintf(f,"    strb %s,[%s],#%d\n",pix1,scr,calcOffset(3,3,i));
			break;
		case 0xC:
			fprintf(f,"    add %s,%s,#2\n",scr,scr);
			fprintf(f,"    mov %s,%s,lsr#16\n",pix1,pix1);
			fprintf(f,"    strb %s,[%s],#1\n",pix1,scr);
			fprintf(f,"    mov %s,%s,lsr#8\n",pix1,pix1);
			fprintf(f,"    strb %s,[%s],#%d\n",pix1,scr,calcOffset(3,3,i));
			break;
		case 0xD:
			fprintf(f,"    strb %s,[%s],#2\n",pix1,scr);
			fprintf(f,"    mov %s,%s,lsr#16\n",pix1,pix1);
			fprintf(f,"    strb %s,[%s],#1\n",pix1,scr);
			fprintf(f,"    mov %s,%s,lsr#8\n",pix1,pix1);
			fprintf(f,"    strb %s,[%s],#%d\n",pix1,scr,calcOffset(3,3,i));
			break;
		case 0xE:
			fprintf(f,"    add %s,%s,#1\n",scr,scr);
			fprintf(f,"    mov %s,%s,lsr#8\n",pix1,pix1);
			fprintf(f,"    strb %s,[%s],#1\n",pix1,scr);
			fprintf(f,"    mov %s,%s,lsr#8\n",pix1,pix1);
			fprintf(f,"    strb %s,[%s],#1\n",pix1,scr);
			fprintf(f,"    mov %s,%s,lsr#8\n",pix1,pix1);
			fprintf(f,"    strb %s,[%s],#%d\n",pix1,scr,calcOffset(3,3,i));
			break;
		case 0xF:
			fprintf(f,"    strb %s,[%s],#1\n",pix1,scr);
			fprintf(f,"    mov %s,%s,lsr#8\n",pix1,pix1);
			fprintf(f,"    strb %s,[%s],#1\n",pix1,scr);
			fprintf(f,"    mov %s,%s,lsr#8\n",pix1,pix1);
			fprintf(f,"    strb %s,[%s],#1\n",pix1,scr);
			fprintf(f,"    mov %s,%s,lsr#8\n",pix1,pix1);
			fprintf(f,"    strb %s,[%s],#%d\n",pix1,scr,calcOffset(3,3,i));
			break;
		}

		switch((i&0xF0)>>4)
		{
		case 0:
			// Already taken care of, so do nothing
			break;
		case 1:
			fprintf(f,"    strb %s,[%s],#%d\n",pix2,scr,calcOffset(4,4,i));
			break;
		case 2:
			fprintf(f,"    mov %s,%s,lsr#8\n",pix2,pix2);
			fprintf(f,"    strb %s,[%s],#%d\n",pix2,scr,calcOffset(4,4,i));
			break;
		case 3:
			fprintf(f,"    strb %s,[%s],#1\n",pix2,scr);
			fprintf(f,"    mov %s,%s,lsr#8\n",pix2,pix2);
			fprintf(f,"    strb %s,[%s],#%d\n",pix2,scr,calcOffset(5,5,i));
			break;
		case 4:
			fprintf(f,"    mov %s,%s,lsr#16\n",pix2,pix2);
			fprintf(f,"    strb %s,[%s],#%d\n",pix2,scr,calcOffset(6,6,i));
			break;
		case 5:
			fprintf(f,"    strb %s,[%s],#2\n",pix2,scr);
			fprintf(f,"    mov %s,%s,lsr#16\n",pix2,pix2);
			fprintf(f,"    strb %s,[%s],#%d\n",pix2,scr,calcOffset(6,6,i));
			break;
		case 6:
			fprintf(f,"    mov %s,%s,lsr#8\n",pix2,pix2);
			fprintf(f,"    strb %s,[%s],#1\n",pix2,scr);
			fprintf(f,"    mov %s,%s,lsr#8\n",pix2,pix2);
			fprintf(f,"    strb %s,[%s],#%d\n",pix2,scr,calcOffset(6,6,i));
			break;
		case 7:
			fprintf(f,"    strb %s,[%s],#1\n",pix2,scr);
			fprintf(f,"    mov %s,%s,lsr#8\n",pix2,pix2);
			fprintf(f,"    strb %s,[%s],#1\n",pix2,scr);
			fprintf(f,"    mov %s,%s,lsr#16\n",pix2,pix2);
			fprintf(f,"    strb %s,[%s],#%d\n",pix2,scr,calcOffset(6,6,i));
			break;
		case 8:
			fprintf(f,"    mov %s,%s,lsr#24\n",pix2,pix2);
			fprintf(f,"    strb %s,[%s],#%d\n",pix2,scr,calcOffset(7,7,i));
			break;
		case 9:
			fprintf(f,"    strb %s,[%s],#3\n",pix2,scr);
			fprintf(f,"    mov %s,%s,lsr#24\n",pix2,pix2);
			fprintf(f,"    strb %s,[%s],#%d\n",pix2,scr,calcOffset(7,7,i));
			break;
		case 0xA:
			fprintf(f,"    mov %s,%s,lsr#8\n",pix2,pix2);
			fprintf(f,"    strb %s,[%s],#2\n",pix2,scr);
			fprintf(f,"    mov %s,%s,lsr#16\n",pix2,pix2);
			fprintf(f,"    strb %s,[%s],#%d\n",pix2,scr,calcOffset(7,7,i));
			break;
		case 0xB:
			fprintf(f,"    strb %s,[%s],#1\n",pix2,scr);
			fprintf(f,"    mov %s,%s,lsr#8\n",pix2,pix2);
			fprintf(f,"    strb %s,[%s],#2\n",pix2,scr);
			fprintf(f,"    mov %s,%s,lsr#16\n",pix2,pix2);
			fprintf(f,"    strb %s,[%s],#%d\n",pix2,scr,calcOffset(7,7,i));
			break;
		case 0xC:
			fprintf(f,"    mov %s,%s,lsr#16\n",pix2,pix2);
			fprintf(f,"    strb %s,[%s],#1\n",pix2,scr);
			fprintf(f,"    mov %s,%s,lsr#8\n",pix2,pix2);
			fprintf(f,"    strb %s,[%s],#%d\n",pix2,scr,calcOffset(7,7,i));
			break;
		case 0xD:
			fprintf(f,"    strb %s,[%s],#2\n",pix2,scr);
			fprintf(f,"    mov %s,%s,lsr#16\n",pix2,pix2);
			fprintf(f,"    strb %s,[%s],#1\n",pix2,scr);
			fprintf(f,"    mov %s,%s,lsr#8\n",pix2,pix2);
			fprintf(f,"    strb %s,[%s],#%d\n",pix2,scr,calcOffset(7,7,i));
			break;
		case 0xE:
			fprintf(f,"    mov %s,%s,lsr#8\n",pix2,pix2);
			fprintf(f,"    strb %s,[%s],#1\n",pix2,scr);
			fprintf(f,"    mov %s,%s,lsr#8\n",pix2,pix2);
			fprintf(f,"    strb %s,[%s],#1\n",pix2,scr);
			fprintf(f,"    mov %s,%s,lsr#8\n",pix2,pix2);
			fprintf(f,"    strb %s,[%s],#%d\n",pix2,scr,calcOffset(7,7,i));
			break;
		case 0xF:
			fprintf(f,"    strb %s,[%s],#1\n",pix2,scr);
			fprintf(f,"    mov %s,%s,lsr#8\n",pix2,pix2);
			fprintf(f,"    strb %s,[%s],#1\n",pix2,scr);
			fprintf(f,"    mov %s,%s,lsr#8\n",pix2,pix2);
			fprintf(f,"    strb %s,[%s],#1\n",pix2,scr);
			fprintf(f,"    mov %s,%s,lsr#8\n",pix2,pix2);
			fprintf(f,"    strb %s,[%s],#%d\n",pix2,scr,calcOffset(7,7,i));
			break;
		}
		fprintf(f,"    subs r1,r1,#1\n");
		fprintf(f,"    ldrneb r3,[r0],#1\n");
		fprintf(f,"    ldrne pc,[r4,r3,lsl#2]\n");
		fprintf(f,"    ldmfd sp!,{r4,r5,pc}\n");

	}
	
	// Align 0
	for(i=0;i<0x100;i++)
	{
		int pix_data_read = 0;
		fprintf(f,"drawtile_align0_%x:\n",i);
		if ((i&0xF)&&(i&0xF0))
		{
			fprintf(f,"    ldmia r5!,{r3,r12}\n");
			pix_data_read = 1;
		}
		else if ((i&0x3)&&(i&0xC))
		{
			fprintf(f,"    ldr r3,[r5],#8\n");
		}
		else if (i&0x3)
		{
			fprintf(f,"    ldrh r3,[r5],#8\n");
		}
		else if (i&0xC)
		{
			fprintf(f,"    add r5,r5,#2\n");
			fprintf(f,"    ldrh r3,[r5],#6\n");
		}
		else if ((i&0x30)&&(i&0xC0))
		{
			fprintf(f,"    add r5,r5,#4\n");
			fprintf(f,"    ldr r12,[r5],#4\n");
		}
		else if (i&0x30)
		{
			fprintf(f,"    add r5,r5,#4\n");
			fprintf(f,"    ldrh r3,[r5],#4\n");
		}
		else if (i&0xC0)
		{
			fprintf(f,"    add r5,r5,#6\n");
			fprintf(f,"    ldrh r3,[r5],#2\n");
		}

		switch(i&0xF)
		{
		case 0: //0000
			fprintf(f,"    add %s,%s,#%d\n",scr,scr,calcOffset(0,0,i));
			break;
		case 1: //0001
			fprintf(f,"    strb %s,[%s],#%d\n",pix1,scr,calcOffset(0,0,i));
			break;
		case 2: //0010
			fprintf(f,"    add %s,%s,#1\n",scr,scr);
			fprintf(f,"    mov %s,%s,lsr#8\n",pix1,pix1);
			fprintf(f,"    strb %s,[%s],#%d\n",pix1,scr,calcOffset(1,1,i));
			break;
		case 3: //0011
			
			//Check if this is going to be end pix
			if(calcOffset(0,1,i) > 8)
			{
				fprintf(f,"    strh %s,[%s]\n",pix1,scr);
				fprintf(f,"    add %s,%s,#320\n",scr,scr);
			}
			else
			{
				fprintf(f,"    strh %s,[%s],#%d\n",pix1,scr,calcOffset(0,1,i));
			}
			
			break;
		case 4: //0100
			fprintf(f,"    add %s,%s,#2\n",scr,scr);
			fprintf(f,"    mov %s,%s,lsr#16\n",pix1,pix1);
			fprintf(f,"    strb %s,[%s],#%d\n",pix1,scr,calcOffset(2,2,i));
			break;
		case 5: //0101
			fprintf(f,"    strb %s,[%s],#2\n",pix1,scr);
			fprintf(f,"    mov %s,%s,lsr#16\n",pix1,pix1);
			fprintf(f,"    strb %s,[%s],#%d\n",pix1,scr,calcOffset(2,2,i));
			break;
		case 6: //0110
			fprintf(f,"    add %s,%s,#1\n",scr,scr);
			fprintf(f,"    mov %s,%s,lsr#8\n",pix1,pix1);
			fprintf(f,"    strb %s,[%s],#1\n",pix1,scr);
			fprintf(f,"    mov %s,%s,lsr#8\n",pix1,pix1);
			fprintf(f,"    strb %s,[%s],#%d\n",pix1,scr,calcOffset(2,2,i));
			break;
		case 7: //0111
			fprintf(f,"    strh %s,[%s],#2\n",pix1,scr);
			fprintf(f,"    mov %s,%s,lsr#16\n",pix1,pix1);
			fprintf(f,"    strb %s,[%s],#%d\n",pix1,scr,calcOffset(2,2,i));
			break;
		case 8: //1000
			fprintf(f,"    add %s,%s,#3\n",scr,scr);
			fprintf(f,"    mov %s,%s,lsr#24\n",pix1,pix1);
			fprintf(f,"    strb %s,[%s],#%d\n",pix1,scr,calcOffset(3,3,i));
			break;
		case 9: //1001
			fprintf(f,"    strb %s,[%s],#3\n",pix1,scr);
			fprintf(f,"    mov %s,%s,lsr#24\n",pix1,pix1);
			fprintf(f,"    strb %s,[%s],#%d\n",pix1,scr,calcOffset(3,3,i));
			break;
		case 0xA: //1010
			fprintf(f,"    add %s,%s,#1\n",scr,scr);
			fprintf(f,"    mov %s,%s,lsr#8\n",pix1,pix1);
			fprintf(f,"    strb %s,[%s],#2\n",pix1,scr);
			fprintf(f,"    mov %s,%s,lsr#16\n",pix1,pix1);
			fprintf(f,"    strb %s,[%s],#%d\n",pix1,scr,calcOffset(3,3,i));
			break;
		case 0xB: //1011
			fprintf(f,"    strh %s,[%s],#3\n",pix1,scr);
			fprintf(f,"    mov %s,%s,lsr#24\n",pix1,pix1);
			fprintf(f,"    strb %s,[%s],#%d\n",pix1,scr,calcOffset(3,3,i));
			break;
		case 0xC: //1100
			fprintf(f,"    add %s,%s,#2\n",scr,scr);
			fprintf(f,"    mov %s,%s,lsr#16\n",pix1,pix1);
			if(calcOffset(2,3,i) > 8)
			{
				fprintf(f,"    strh %s,[%s],#-2\n",pix1,scr);
				fprintf(f,"    add %s,%s,#320\n",scr,scr);
			}
			else
			{
				fprintf(f,"    strh %s,[%s],#%d\n",pix1,scr,calcOffset(2,3,i));
			}
			break;
		case 0xD: //1101
			fprintf(f,"    strb %s,[%s],#2\n",pix1,scr);
			fprintf(f,"    mov %s,%s,lsr#16\n",pix1,pix1);
			if(calcOffset(2,3,i) > 8)
			{
				fprintf(f,"    strh %s,[%s],#-2\n",pix1,scr);
				fprintf(f,"    add %s,%s,#320\n",scr,scr);
			}
			else
			{
				fprintf(f,"    strh %s,[%s],#%d\n",pix1,scr,calcOffset(2,3,i));
			}
			break;
		case 0xE: //1110
			fprintf(f,"    add %s,%s,#1\n",scr,scr);
			fprintf(f,"    mov %s,%s,lsr#8\n",pix1,pix1);
			fprintf(f,"    strb %s,[%s],#1\n",pix1,scr);
			fprintf(f,"    mov %s,%s,lsr#8\n",pix1,pix1);
			if(calcOffset(2,3,i) > 8)
			{
				fprintf(f,"    strh %s,[%s],#-2\n",pix1,scr);
				fprintf(f,"    add %s,%s,#320\n",scr,scr);
			}
			else
			{
				fprintf(f,"    strh %s,[%s],#%d\n",pix1,scr,calcOffset(2,3,i));
			}
			break;
		case 0xF: //1111
			fprintf(f,"    str %s,[%s],#%d\n",pix1,scr,calcOffset(0,3,i));
			break;
		}

		switch((i&0xF0)>>4)
		{
		case 0: // 0000 XXXX
			// Already taken care of, so do nothing
			break;
		case 1: // 0001 XXXX
			fprintf(f,"    strb %s,[%s],#%d\n",pix2,scr,calcOffset(4,4,i));
			break;
		case 2: // 0010 XXXX
			fprintf(f,"    mov %s,%s,lsr#8\n",pix2,pix2);
			fprintf(f,"    strb %s,[%s],#%d\n",pix2,scr,calcOffset(4,4,i));
			break;
		case 3: // 0011 XXXX
			fprintf(f,"    strh %s,[%s],#-4\n",pix2,scr);
			fprintf(f,"    add %s,%s,#320\n",scr,scr);
			break;
		case 4: // 0100 XXXX
			fprintf(f,"    mov %s,%s,lsr#16\n",pix2,pix2);
			fprintf(f,"    strb %s,[%s],#%d\n",pix2,scr,calcOffset(6,6,i));
			break;
		case 5: // 0101 XXXX
			fprintf(f,"    strb %s,[%s],#2\n",pix2,scr);
			fprintf(f,"    mov %s,%s,lsr#16\n",pix2,pix2);
			fprintf(f,"    strb %s,[%s],#%d\n",pix2,scr,calcOffset(6,6,i));
			break;
		case 6: // 0110 XXXX
			fprintf(f,"    mov %s,%s,lsr#8\n",pix2,pix2);
			fprintf(f,"    strb %s,[%s],#1\n",pix2,scr);
			fprintf(f,"    mov %s,%s,lsr#8\n",pix2,pix2);
			fprintf(f,"    strb %s,[%s],#%d\n",pix2,scr,calcOffset(6,6,i));
			break;
		case 7: // 0111 XXXX
			fprintf(f,"    strh %s,[%s],#2\n",pix2,scr);
			fprintf(f,"    mov %s,%s,lsr#16\n",pix2,pix2);
			fprintf(f,"    strb %s,[%s],#%d\n",pix2,scr,calcOffset(6,6,i));
			break;
		case 8: // 1000 XXXX
			fprintf(f,"    mov %s,%s,lsr#24\n",pix2,pix2);
			fprintf(f,"    strb %s,[%s],#%d\n",pix2,scr,calcOffset(7,7,i));
			break;
		case 9: // 1001 XXXX
			fprintf(f,"    strb %s,[%s],#3\n",pix2,scr);
			fprintf(f,"    mov %s,%s,lsr#24\n",pix2,pix2);
			fprintf(f,"    strb %s,[%s],#%d\n",pix2,scr,calcOffset(7,7,i));
			break;
		case 0xA: // 1010 XXXX
			fprintf(f,"    mov %s,%s,lsr#8\n",pix2,pix2);
			fprintf(f,"    strb %s,[%s],#2\n",pix2,scr);
			fprintf(f,"    mov %s,%s,lsr#16\n",pix2,pix2);
			fprintf(f,"    strb %s,[%s],#%d\n",pix2,scr,calcOffset(7,7,i));
			break;
		case 0xB: // 1011 XXXX
			fprintf(f,"    strh %s,[%s],#3\n",pix2,scr);
			fprintf(f,"    mov %s,%s,lsr#24\n",pix2,pix2);
			fprintf(f,"    strb %s,[%s],#%d\n",pix2,scr,calcOffset(7,7,i));
			break;
		case 0xC: // 1100 XXXX
			fprintf(f,"    mov %s,%s,lsr#16\n",pix2,pix2);
			fprintf(f,"    strh %s,[%s],#-6\n",pix2,scr);
			fprintf(f,"    add %s,%s,#320\n",scr,scr);
			break;
		case 0xD: // 1101 XXXX
			fprintf(f,"    strb %s,[%s],#2\n",pix2,scr);
			fprintf(f,"    mov %s,%s,lsr#16\n",pix2,pix2);
			fprintf(f,"    strh %s,[%s],#-6\n",pix2,scr);
			fprintf(f,"    add %s,%s,#320\n",scr,scr);
			break;
		case 0xE: // 1110 XXXX
			fprintf(f,"    mov %s,%s,lsr#8\n",pix2,pix2);
			fprintf(f,"    strb %s,[%s],#1\n",pix2,scr);
			fprintf(f,"    mov %s,%s,lsr#8\n",pix2,pix2);
			fprintf(f,"    strh %s,[%s],#-6\n",pix2,scr);
			fprintf(f,"    add %s,%s,#320\n",scr,scr);
			break;
		case 0xF:
			fprintf(f,"    str %s,[%s],#%d\n",pix2,scr,calcOffset(4,7,i));
			break;
		}
		fprintf(f,"    subs r1,r1,#1\n");
		fprintf(f,"    ldrneb r3,[r0],#1\n");
		fprintf(f,"    ldrne pc,[r4,r3,lsl#2]\n");
		fprintf(f,"    ldmfd sp!,{r4,r5,pc}\n");

	}

	

	fclose(f);
	return(0);
}

void main(int argc,char **argv)
{	

	generate_code8("render8.S");

}