#include <string>
#include "surface.h"
#include "checkboxmenu.h"
using namespace std;

namespace hm
{

	CheckboxMenu::CheckboxMenu(string title,Surface *surface) :
		Menu(title,surface)
	{
		state = false;
		value = "false";
	}

	void CheckboxMenu::drawListItem(Surface *surface,int x,int y,int w,int h,bool selected)
   {
		state = value=="true";
		x += windowPadding;
		y += windowPadding;
		surface->drawCheckbox(x,y,state);
		x += surface->getCheckboxSize() + windowPadding;
		surface->drawText(title,x,y-2,selected?SELECTED:NORMAL);
	}

	int CheckboxMenu::getListItemHeight()
   {
		return(getSurface()->getCheckboxSize() + windowPadding*2);
	}

	int CheckboxMenu::enter()
   {

		// fire enter event
		if (actionHandler!=NULL)
			actionHandler->enter(this);

		state = value=="true";
		state = !state;
		setValue(state?"true":"false");

		if (actionHandler!=NULL)
			actionHandler->change(this);

      return 0;
	}

};
