#ifndef __checkboxmenu_h__
#define __checkboxmenu_h__

#include "menu.h"

namespace hm {

	/**
		Checkbox. It does not pop-up a window like other Menu subclasses, but 
		rather just toggles on/off.
	*/
	class CheckboxMenu : public Menu {

	public:
		
		/** 
			constructor
			\param title the title of the menu, it will usually show in the list and on the window header
			\param surface a surface to draw on. The root node should always have a non-NULL Surface object
			specified, child nodes will inherit their parent's Surface when appendChild is called.
		*/
		CheckboxMenu(string title,Surface *surface = NULL);

		virtual void drawListItem(Surface *surface,int x,int y,int w,int h,bool selected);
		virtual int getListItemHeight();
		virtual int enter();

	private:
		bool state;
	};


};

#endif
