#ifndef __filemenuitem_h__
#define __filemenuitem_h__

#include "actionmenu.h"
#include "filemenu.h"
#include "system.h"

namespace hm
{

	/**
		Used by FileMenu
	*/
	class FileMenuItem: public ActionMenu
   {
	
	public:

		/** 
			constructor
			\param title the title of the menu, it will usually show in the list and on the window header
			\param surface a surface to draw on. The root node should always have a non-NULL Surface object
			specified, child nodes will inherit their parent's Surface when appendChild is called.
		*/
		FileMenuItem(string title,Surface *surface = NULL);

		/** \returns <bool> true if the item is a directory */
		FileDescription getFileDescription();

		/** sets wether the item is a directory
			\param <bool> true if the item is a directory
		*/
		void setFileDescription(FileDescription fd);

	private:
		
		FileDescription fileDescription;

	};


};

#endif
