#include <string>
#include "surface.h"
#include "squidgemenu.h"
#include "system.h"
#include "math.h"
using namespace std;

int battChargeLevel (void);

namespace hm {

	SquidgeMenu::SquidgeMenu(string title,Surface *surface) :
		Menu(title,surface)
	{
		setValue("");
		setWindowSize(280,200);
		selected=0;
	}

	void SquidgeMenu::draw()
   {
      int battX = 148, battY = 212, battWidth = 26, battHeight = 10, chargelvl = 100;
      int battNeededWidth;

		Surface *surface = getSurface();

		surface->drawImage(background,0,0);

		// center the window to the surface
		if ((x==-1)||(y==-1)) {
			x = (surface->getWidth() - width) / 2;
			y = (surface->getHeight() - height) / 2;
		}

		// terrible hack, temporarily set the list background color to purple (transparent)
		int tempColor = surface->getSkinColor(LISTBACKGROUND);
		surface->setSkinColor(LISTBACKGROUND,0xff00ff);

		drawList(
			x,
			y,
			width,
			height);

		// restore the listbackground color
		surface->setSkinColor(LISTBACKGROUND,tempColor);

      // draw the battery - body
      surface->drawRect(battX,battY,battWidth-2,battHeight,0);
      surface->drawRect(battX+1,battY+1,battWidth-4,battHeight-2,0xAAAAAA);
      // Charge level
      battNeededWidth = (int) (((battWidth-6)/100.0) * battChargeLevel());
      surface->drawRect(battX+2,battY+2,battNeededWidth,battHeight-4,0);
      // nib
      surface->drawRect((battX+(battWidth-2)),battY+2,2,battHeight-4,0);

		surface->flip();

	}

};
